/**
* Cʵֵĺ(Red Black Tree)
*
* @author skywang
* @date 2013/11/18
*/
#pragma once
#include <stdio.h>
#include <stdlib.h>
#include "rbtree.h"
#define rb_parent(r)   ((r)->parent)
#define rb_color(r) ((r)->color)
#define rb_is_red(r)   ((r)->color==RED)
#define rb_is_black(r)  ((r)->color==BLACK)
#define rb_set_black(r)  do { (r)->color = BLACK; } while (0)
#define rb_set_red(r)  do { (r)->color = RED; } while (0)
#define rb_set_parent(r,p)  do { (r)->parent = (p); } while (0)
#define rb_set_color(r,c)  do { (r)->color = (c); } while (0)

/*
* "ĸ"
*/
RBRoot* create_rbtree()
{
	RBRoot *root = (RBRoot *)malloc(sizeof(RBRoot));
	root->node = NULL;

	return root;
}


/*
* ""
*/
int ListTraverse(LinkList L)
{
	LinkList p = L->next;
	while (p)
	{
		printf("%d ", p->data);
		p = p->next;
	}
	printf("\n");
	return 1;
}
static void inorder(RBTree tree)
{
	if (tree != NULL)
	{
		inorder(tree->left);
		printf("%s:", tree->key.filename);
		ListTraverse(tree->key.index);
		inorder(tree->right);
	}
}
void inorder_rbtree(RBRoot *root)
{
	if (root)
		inorder(root->node);
}


/*
* (ݹʵ)"x"мֵΪkeyĽڵ
*/
static Node* search(RBTree x, int key)
{
	if (x == NULL || x->key.hashfile == key)
		return x;

	if (key < x->key.hashfile)
		return search(x->left, key);
	else
		return search(x->right, key);
}
RBleaf* rbtree_search(RBRoot *root, int key) 
{
	if (root) {
		Node* temp = search(root->node, key);
		if ( temp!= NULL)
		{
			return &temp->key;
		}
	}
	return NULL;
}

/*
* ҽ(x)ĺ̽㡣"ֵڸý""С"
*/
static Node* rbtree_successor(RBTree x)
{
	// xҺӣ"xĺ̽"Ϊ "ҺΪС"
	if (x->right != NULL)
		return minimum(x->right);

	// xûҺӡxֿܣ
	// (01) x"һ""xĺ̽"Ϊ "ĸ"
	// (02) x"һҺ""x͵ĸ㣬ҸøҪ"ҵ"͵ĸ""xĺ̽"
	Node* y = x->parent;
	while ((y != NULL) && (x == y->right))
	{
		x = y;
		y = y->parent;
	}

	return y;
}

/*
* ҽ(x)ǰ㡣"ֵСڸý"""
*/
static Node* rbtree_predecessor(RBTree x)
{
	// xӣ"xǰ"Ϊ "Ϊ"
	if (x->left != NULL)
		return maximum(x->left);

	// xûӡxֿܣ
	// (01) x"һҺ""xǰ"Ϊ "ĸ"
	// (01) x"һ""x͵ĸ㣬ҸøҪҺ"ҵ"͵ĸ""xǰ"
	Node* y = x->parent;
	while ((y != NULL) && (x == y->left))
	{
		x = y;
		y = y->parent;
	}

	return y;
}

/*
* ԺĽڵ(x)ת
*
* ʾͼ(Խڵx)
*      px                              px
*     /                               /
*    x                               y
*   /  \      --()-->           / \                #
*  lx   y                          x  ry
*     /   \                       /  \
*    ly   ry                     lx  ly
*
*
*/
static void rbtree_left_rotate(RBRoot *root, Node *x)
{
	// xҺΪy
	Node *y = x->right;

	//  yӡ Ϊ xҺӡ
	// yӷǿգ x Ϊ yӵĸס
	x->right = y->left;
	if (y->left != NULL)
		y->left->parent = x;

	//  xĸס Ϊ yĸס
	y->parent = x->parent;

	if (x->parent == NULL)
	{
		//tree = y;            //  xĸס ǿսڵ㣬yΪڵ
		root->node = y;            //  xĸס ǿսڵ㣬yΪڵ
	}
	else
	{
		if (x->parent->left == x)
			x->parent->left = y;    //  xڵӣyΪxĸڵӡ
		else
			x->parent->right = y;    //  xڵӣyΪxĸڵӡ
	}

	//  x Ϊ yӡ
	y->left = x;
	//  xĸڵ㡱 Ϊ y
	x->parent = y;
}

/*
* ԺĽڵ(y)ת
*
* ʾͼ(Խڵy)
*            py                               py
*           /                                /
*          y                                x
*         /  \      --()-->            /  \                     #
*        x   ry                           lx   y
*       / \                                   / \                   #
*      lx  rx                                rx  ry
*
*/
static void rbtree_right_rotate(RBRoot *root, Node *y)
{
	// xǵǰڵӡ
	Node *x = y->left;

	//  xҺӡ Ϊ yӡ
	// "xҺ"ΪյĻ y Ϊ xҺӵĸס
	y->left = x->right;
	if (x->right != NULL)
		x->right->parent = y;

	//  yĸס Ϊ xĸס
	x->parent = y->parent;

	if (y->parent == NULL)
	{
		//tree = x;            //  yĸס ǿսڵ㣬xΪڵ
		root->node = x;            //  yĸס ǿսڵ㣬xΪڵ
	}
	else
	{
		if (y == y->parent->right)
			y->parent->right = x;    //  yڵҺӣxΪyĸڵҺӡ
		else
			y->parent->left = x;    // (yڵ) xΪxĸڵӡ
	}

	//  y Ϊ xҺӡ
	x->right = y;

	//  yĸڵ㡱 Ϊ x
	y->parent = x;
}

/*
* 
*
* вڵ֮(ʧȥƽ)ٵøú
* Ŀǽһź
*
* ˵
*     root ĸ
*     node Ľ        // Ӧ㷨ۡеz
*/
static void rbtree_insert_fixup(RBRoot *root, Node *node)
{
	Node *parent, *gparent;

	// ڵڣҸڵɫǺɫ
	while ((parent = rb_parent(node)) && rb_is_red(parent))
	{
		gparent = rb_parent(parent);

		//ڵ㡱ǡ游ڵӡ
		if (parent == gparent->left)
		{
			// Case 1ڵǺɫ
			{
				Node *uncle = gparent->right;
				if (uncle && rb_is_red(uncle))
				{
					rb_set_black(uncle);
					rb_set_black(parent);
					rb_set_red(gparent);
					node = gparent;
					continue;
				}
			}

			// Case 2ǺɫҵǰڵҺ
			if (parent->right == node)
			{
				Node *tmp;
				rbtree_left_rotate(root, parent);
				tmp = parent;
				parent = node;
				node = tmp;
			}

			// Case 3Ǻɫҵǰڵӡ
			rb_set_black(parent);
			rb_set_red(gparent);
			rbtree_right_rotate(root, gparent);
		}
		else//zĸڵ㡱ǡz游ڵҺӡ
		{
			// Case 1ڵǺɫ
			{
				Node *uncle = gparent->left;
				if (uncle && rb_is_red(uncle))
				{
					rb_set_black(uncle);
					rb_set_black(parent);
					rb_set_red(gparent);
					node = gparent;
					continue;
				}
			}

			// Case 2Ǻɫҵǰڵ
			if (parent->left == node)
			{
				Node *tmp;
				rbtree_right_rotate(root, parent);
				tmp = parent;
				parent = node;
				node = tmp;
			}

			// Case 3ǺɫҵǰڵҺӡ
			rb_set_black(parent);
			rb_set_red(gparent);
			rbtree_left_rotate(root, gparent);
		}
	}

	// ڵΪɫ
	rb_set_black(root->node);
}

/*
* ӽڵ㣺ڵ(node)뵽
*
* ˵
*     root ĸ
*     node Ľ        // Ӧ㷨ۡеz
*/
static void rbtree_insert(RBRoot *root, Node *node)
{
	Node *y = NULL;
	Node *x = root->node;

	// 1. һŶڵӵС
	while (x != NULL)
	{
		y = x;
		if (node->key.hashfile < x->key.hashfile)
			x = x->left;
		else
			x = x->right;
	}
	rb_parent(node) = y;

	if (y != NULL)
	{
		if (node->key.hashfile < y->key.hashfile)
			y->left = node;                // 2nodeֵ < yֵnodeΪyӡ
		else
			y->right = node;            // 3(nodeֵ >= yֵ)nodeΪyҺӡ
	}
	else
	{
		root->node = node;                // 1yǿսڵ㣬nodeΪ
	}

	// 2. ýڵɫΪɫ
	node->color = RED;

	// 3. ΪһŶ
	rbtree_insert_fixup(root, node);
}

/*
* 
*
* ˵
*     key Ǽֵ
*     parent Ǹ㡣
*     left ӡ
*     right Һӡ
*/
static Node* create_rbtree_node(RBleaf key, Node *parent, Node *left, Node* right)
{
	Node* p;

	if ((p = (Node *)malloc(sizeof(Node))) == NULL)
		return NULL;
	p->key = key;
	p->left = left;
	p->right = right;
	p->parent = parent;
	p->color = BLACK; // ĬΪɫ

	return p;
}

/*
* ½(ڵֵΪkey)뵽
*
* ˵
*     root ĸ
*     key ļֵ
* ֵ
*     0ɹ
*     -1ʧ
*/
int insert_rbtree(RBRoot *root, RBleaf key)
{
	Node *node;    // ½

				   // ֵͬĽڵ㡣
				   // (ֵͬĽڵ㣬ע͵仰ɣ)
	if (search(root->node, key.hashfile) != NULL)
		return -1;

	// ½ʧܣ򷵻ء
	if ((node = create_rbtree_node(key, NULL, NULL, NULL)) == NULL)
		return -1;

	rbtree_insert(root, node);

	return 0;
}

/*
* ɾ
*
* ڴӺɾڵ֮(ʧȥƽ)ٵøú
* Ŀǽһź
*
* ˵
*     root ĸ
*     node Ľڵ
*/
static void rbtree_delete_fixup(RBRoot *root, Node *node, Node *parent)
{
	Node *other;

	while ((!node || rb_is_black(node)) && node != root->node)
	{
		if (parent->left == node)
		{
			other = parent->right;
			if (rb_is_red(other))
			{
				// Case 1: xֵwǺɫ
				rb_set_black(other);
				rb_set_red(parent);
				rbtree_left_rotate(root, parent);
				other = parent->right;
			}
			if ((!other->left || rb_is_black(other->left)) &&
				(!other->right || rb_is_black(other->right)))
			{
				// Case 2: xֵwǺɫwҲǺɫ
				rb_set_red(other);
				node = parent;
				parent = rb_parent(node);
			}
			else
			{
				if (!other->right || rb_is_black(other->right))
				{
					// Case 3: xֵwǺɫģwǺɫҺΪɫ
					rb_set_black(other->left);
					rb_set_red(other);
					rbtree_right_rotate(root, other);
					other = parent->right;
				}
				// Case 4: xֵwǺɫģwҺǺɫģɫ
				rb_set_color(other, rb_color(parent));
				rb_set_black(parent);
				rb_set_black(other->right);
				rbtree_left_rotate(root, parent);
				node = root->node;
				break;
			}
		}
		else
		{
			other = parent->left;
			if (rb_is_red(other))
			{
				// Case 1: xֵwǺɫ
				rb_set_black(other);
				rb_set_red(parent);
				rbtree_right_rotate(root, parent);
				other = parent->left;
			}
			if ((!other->left || rb_is_black(other->left)) &&
				(!other->right || rb_is_black(other->right)))
			{
				// Case 2: xֵwǺɫwҲǺɫ
				rb_set_red(other);
				node = parent;
				parent = rb_parent(node);
			}
			else
			{
				if (!other->left || rb_is_black(other->left))
				{
					// Case 3: xֵwǺɫģwǺɫҺΪɫ
					rb_set_black(other->right);
					rb_set_red(other);
					rbtree_left_rotate(root, other);
					other = parent->left;
				}
				// Case 4: xֵwǺɫģwҺǺɫģɫ
				rb_set_color(other, rb_color(parent));
				rb_set_black(parent);
				rb_set_black(other->left);
				rbtree_right_rotate(root, parent);
				node = root->node;
				break;
			}
		}
	}
	if (node)
		rb_set_black(node);
}

/*
* ɾ
*
* ˵
*     tree ĸ
*     node ɾĽ
*/
void rbtree_delete(RBRoot *root, Node *node)
{
	Node *child, *parent;
	int color;

	// ɾڵ"ҺӶΪ"
	if ((node->left != NULL) && (node->right != NULL))
	{
		// ɾڵĺ̽ڵ㡣(Ϊ"ȡڵ")
		// ȡ"ɾڵ"λãȻٽ"ɾڵ"ȥ
		Node *replace = node;

		// ȡ̽ڵ
		replace = replace->right;
		while (replace->left != NULL)
			replace = replace->left;

		// "nodeڵ"Ǹڵ(ֻиڵ㲻ڸڵ)
		if (rb_parent(node))
		{
			if (rb_parent(node)->left == node)
				rb_parent(node)->left = replace;
			else
				rb_parent(node)->right = replace;
		}
		else
			// "nodeڵ"Ǹڵ㣬¸ڵ㡣
			root->node = replace;

		// child"ȡڵ"ҺӣҲҪ"Ľڵ"
		// "ȡڵ"϶ӣΪһ̽ڵ㡣
		child = replace->right;
		parent = rb_parent(replace);
		// "ȡڵ"ɫ
		color = rb_color(replace);

		// "ɾڵ""ĺ̽ڵĸڵ"
		if (parent == node)
		{
			parent = replace;
		}
		else
		{
			// childΪ
			if (child)
				rb_set_parent(child, parent);
			parent->left = child;

			replace->right = node->right;
			rb_set_parent(node->right, replace);
		}

		replace->parent = node->parent;
		replace->color = node->color;
		replace->left = node->left;
		node->left->parent = replace;

		if (color == BLACK)
			rbtree_delete_fixup(root, child, parent);
		free(node);

		return;
	}

	if (node->left != NULL)
		child = node->left;
	else
		child = node->right;

	parent = node->parent;
	// "ȡڵ"ɫ
	color = node->color;

	if (child)
		child->parent = parent;

	// "nodeڵ"Ǹڵ
	if (parent)
	{
		if (parent->left == node)
			parent->left = child;
		else
			parent->right = child;
	}
	else
		root->node = child;

	if (color == BLACK)
		rbtree_delete_fixup(root, child, parent);
	free(node);
}

/*
* ɾֵΪkeyĽ
*
* ˵
*     tree ĸ
*     key ֵ
*/
void delete_rbtree(RBRoot *root, RBleaf key)
{
	Node *z, *node;

	if ((z = search(root->node, key.hashfile)) != NULL)
		rbtree_delete(root, z);
}

/*
* ٺ
*/
static void rbtree_destroy(RBTree tree)
{
	if (tree == NULL)
		return;

	if (tree->left != NULL)
		rbtree_destroy(tree->left);
	if (tree->right != NULL)
		rbtree_destroy(tree->right);

	free(tree);
}

void destroy_rbtree(RBRoot *root)
{
	if (root != NULL)
		rbtree_destroy(root->node);

	free(root);
}

/*
* ӡ""
*
* tree       -- Ľڵ
* key        -- ڵļֵ
* direction  --  0ʾýڵǸڵ;
*               -1ʾýڵĸ;
*                1ʾýڵĸҺӡ
*/
static void rbtree_print(RBTree tree, RBleaf key, int direction)
{
	if (tree != NULL)
	{
		if (direction == 0)    // treeǸڵ
			printf("%2d(B) is root\n", tree->key);
		else                // treeǷ֧ڵ
			printf("%2d(%s) is %2d's %6s child\n", tree->key, rb_is_red(tree) ? "R" : "B", key, direction == 1 ? "right" : "left");

		rbtree_print(tree->left, tree->key, -1);
		rbtree_print(tree->right, tree->key, 1);
	}
}

void print_rbtree(RBRoot *root)
{
	if (root != NULL && root->node != NULL)
		rbtree_print(root->node, root->node->key, 0);
}
